# =================================================================
# Licensed Materials - Property of IBM
#
# (c) Copyright IBM Corp. 2014, 2015 All Rights Reserved
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
# =================================================================


def sort_instance_bdms(bdms):

    bdms_with_boot_index = []
    bdms_without_boot_index = []

    for bdm in bdms:
        if bdm.boot_index is not None:
            bdms_with_boot_index.append(bdm)
        else:
            bdms_without_boot_index.append(bdm)

    # The BDMs are sorted first by boot_index ascending, and followed
    # by BDMs that do not have a boot_index sorted by id ascending.
    ret_val = sorted(bdms_with_boot_index, key=lambda k: k.boot_index)
    ret_val = ret_val + sorted(bdms_without_boot_index, key=lambda k: k.id)
    return ret_val


def sort_instance_bdm_dict(bdms):

    bdms_with_boot_index = []
    bdms_without_boot_index = []

    for bdm in bdms:
        if 'boot_index' in bdm and bdm['boot_index'] is not None:
            bdms_with_boot_index.append(bdm)
        else:
            bdms_without_boot_index.append(bdm)

    # The BDMs are sorted first by boot_index ascending, and followed
    # by BDMs that do not have a boot_index sorted by id ascending.
    ret_val = sorted(bdms_with_boot_index, key=lambda k: k['boot_index'])
    ret_val = ret_val + sorted(bdms_without_boot_index, key=lambda k: k['id'])
    return ret_val
